# $Id:$

# Copyright (c) 2005 ramok (ramok@core.org.ua)
# Copying: GPL 2.0
# in memory SFoSS

# Search in rank file for www.destinysphere.ru
# Features:
#  - search by regex
#  - colors

# check ds(*) for your settings

# ver. 0.6
#   add colors
#   fix search in alians
# ver. 0.5
#   add POSIX 1003.2 regex
# ver. 0.4
#  add download database in script 
# 
# TODO:
# - more comments and docs ;-)
# - cleanup comments
# - choice english and russian
# - search on several spheres

# Ideas
# ======
# 1) !dsway ramok ed_t02
# 2) !dsnet Stasia


namespace eval ds {}

# global flags
setudef flag nopubds
setudef flag nocolorsds
setudef flag logsds

# public commands
bind pub -     !dshelp   ::ds::pub_dshelp
bind pub -     !dsrank   ::ds::pub_dsrank
bind pub -     !dsname   ::ds::pub_dsname
bind pub -     !dssota   ::ds::pub_dssota
bind pub -     !dsaddr   ::ds::pub_dsaddr
bind pub -     !dsal     ::ds::pub_dsal
bind pub vo|vo !dsrehash ::ds::pub_dsrehash

# every 2 hour
bind TIME -|-  {03 ?0 * * *}  ::ds::rehash
bind TIME -|-  {03 ?2 * * *}  ::ds::rehash
bind TIME -|-  {03 ?4 * * *}  ::ds::rehash
bind TIME -|-  {03 ?6 * * *}  ::ds::rehash
bind TIME -|-  {03 ?8 * * *}  ::ds::rehash

foreach p [array names ds *] {catch {unset ds($p)}}

# database reload time in min.
# set ds(reloadtime) 120

set ds(datadir) "DS_ranking"
set ds(datafile) "$ds(datadir)/ds_ranking_scorpion.cvs"
set ds(tmpfile) "$ds(datadir)/ds_ranking_scorpion.cvs.tmp"

set ds(csvurl) "http://www.destinysphere.ru/ds/csv/ranking_%D1%F4%E5%F0%E0%20%D1%EA%EE%F0%EF%E8%EE%ED%E0.csv.gz"
set ds(download_cmd) "/usr/bin/wget -N -q -O - $ds(csvurl) 2> /dev/null | /bin/zcat 2> /dev/null > $ds(tmpfile)"

#set ds(download_cmd) "/usr/bin/wget -N -q -O $ds(datadir)/ds_ranking_scorpion.cvs.gz $ds(csvurl)> /dev/null 2>&1"

# \017 - plain # \037 - underline # \002 - bolt # \026 - reverse
#  Colors:              #RGB/Html code: Colors:                 #RGB/Html code:
#   White = \00300      #FFFFFF         Yellow = \00308         #F0FF00
#   Black = \00301      #000000         Light Green = \00309    #00F700
#   Blue = \00302       #00007F         Cyan = \00310           #008F8F
#   Green = \00303      #008F00         Light Cyan = \00311     #00F7FF
#   Light Red = \00304  #FF0000         Light Blue = \00312     #0000FF
#   Brown = \00305      #7F0000         Pink = \00313           #FF00FF
#   Purple = \00306     #9F009F         Grey = \00314           #7F7F7F
#   Orange = \00307     #FF7F00         Light Grey = \00315     #CFCFCF

#set ds(color_place)        "\002\00301,15" # gray background

set ds(color_place)        "\00300"
set ds(color_nick)         "\00308"
set ds(color_sots_name)    "\00302"
set ds(color_sots)         "\00310"
set ds(color_al)           "\00305"
set ds(color_race)         "\00315"
set ds(color_rating)       "\00304"

set ds(color_mask)         "\037"

set ds(color_help)         "\00310"

set ds(color_def)          "\037"

# do not change
set ds(ver)		"0.6"
set ds(authors)	"ramok"

set ds(data) ""

proc ::ds::readdata {} {
	global ds
	set ds(data) ""
	if {![catch {set fid [open $ds(datafile) "r"]}]} {
		while {![eof $fid]} {
			set data [split [string trim [gets $fid]] ";"]
			lappend ds(data) $data
#			if {[llength $data] >= 4} {
#				set cdata [list [lindex $data 0] [lindex $data 1]]
#				lappend cdata [string trim [lindex [split [join [lrange $data 2 end]] "="] 0]]
#				lappend cdata [string trim [join [lrange [split [join [lrange $data 2 end]] "="] 1 end] "="]]
#				lappend ds(data) $cdata
#			}
		}
		close $fid
		putlog "\[ds\] loaded [llength $ds(data)] gamers.."
        return "\[ds\] loaded [llength $ds(data)] gamers.."
	} else {
        putlog "\[ds\] can't open file '$ds(datafile)'!"
        return "\[ds\] can't open file '$ds(datafile)'!"
    }
}

proc ::ds::pub_dshelp {nick uhost hand chan args} {
    global ds
    ::ds::out $nick $chan "$ds(color_help)avail commands: !dshelp !dsrank !dsname !dssota !dsaddr !dsal !dsrehash"
    ::ds::out $nick $chan "$ds(color_help)format: !dsCMD \[-\[From\]:\[To\]\] \[rank=\[From\]:\[To\]\] QUERY"
    ::ds::out $nick $chan "$ds(color_help)avail regex POSIX 1003.2"
    ::ds::out $nick $chan "$ds(color_help)example: !dsname ramok || !dsal -3: SFoSS || !dsal rank=3000000:4000000 FAN"
    ::ds::out $nick $chan "$ds(color_help)example: !dsname -4:8 ram || !dsaddr 1.323 || !dssota KoMa."
}

proc ::ds::pub_dsrank {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {[channel get $chan nopubds]} {return}
	regsub -all -- {\\} [join $args] "" args
	::ds::dsrank $nick $uhost 0 $chan [string trim $args]
}

proc ::ds::pub_dsname {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {[channel get $chan nopubds]} {return}
	regsub -all -- {\\} [join $args] "" args
	::ds::dsrank $nick $uhost 1 $chan [string trim $args]
}

proc ::ds::pub_dssota {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {[channel get $chan nopubds]} {return}
	regsub -all -- {\\} [join $args] "" args
	::ds::dsrank $nick $uhost 2 $chan [string trim $args]
}

proc ::ds::pub_dsaddr {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {[channel get $chan nopubds]} {return}
	regsub -all -- {\\} [join $args] "" args
	::ds::dsrank $nick $uhost 3 $chan [string trim $args]
}

proc ::ds::pub_dsal {nick uhost hand chan args} {
	if {![validchan $chan]} {return}
	if {[channel get $chan nopubds]} {return}
	regsub -all -- {\\} [join $args] "" args
	::ds::dsrank $nick $uhost 4 $chan [string trim $args]
}

proc ::ds::dsrank {nick uhost pole chan args} {
	set args [join $args]
	::ds::showdsrank $nick $chan $pole $args
}

proc ::ds::showdsrank {nick chan pole mask} {
	global ds
	if {[llength $ds(data)] == 0} {::ds::out $nick $chan " ..."; return}

	#if {[llength $mask]==0} { ::egglib::outh $nick $chan "!$com" "\[-\] <>"; return	}
	#if {[llength $mask]==0} { ::egglib::outh $nick $chan "!$com" "\[-\] <>"; return	}
	#set query ""; set farg 0; set qnum 1
	set cnt  0
	set showcnt  0

    set snum 1
    set enum 6
    set dilim ""
    set srank 0
    set erank 999999999

    foreach request [split $mask] {
        if { [regexp -nocase -- {^-(\d*)(:*)(\d*)$} [string trim [lindex $request 0]] tr snum dilim enum] } {
            set mask [lindex $mask 1]
            if { $snum == "" } { set snum 1 }
            if { $enum == "" } { set enum [expr $snum + 5] }
            if { $dilim == "" } { set enum $snum }
            continue
        }

        if { [regexp -nocase -- {^rank=(\d*)(:*)(\d*)$} [string trim [lindex $request 0]] tr srank dilim erank] } {
            set mask [lindex $mask 1]
            if { $srank == "" } { set srank 0 }
            if { $erank == "" } { set erank 999999999 }
            if { $dilim == "" } { set erank $srank }
            continue
        }

        set mask $request
    }

    #if { $dilim == "" }{
    #    if { $snum == "" } { set snum 1;  }
    #    if { $enum == "" } { set snum 999999;  }
    #} else {
    #    if { $snum == "" } { set snum 1;  }
    #    if { $enum == "" } { set snum 999999;  }
    #}
    #
    #if { $enum == "" } { set enum 1 }
    #if { $enum == "" } { set enum 1 }

    #TODO:        10..
    #if { $enum > 100 } { set enum 100 }
    if { $snum > $enum } { set snum $enum }

	set mask [string trim [join $mask]]
    ::ds::log $chan "\[ds\] $nick/$chan show $mask"
	set res ""

	if {$mask == ""} {
        set mask $nick
    }

    foreach cdata $ds(data) {
	    if { [regexp -nocase -- $mask [lindex $cdata $pole] mmask tmp] } {
        #if {[string match [::ds::tolower $mask] [::ds::tolower [lindex $cdata $pole]]]} 
            #lappend  res $cdata
            #if { $cnt > $enum } { break }

            set cur_rank [lindex $cdata 6]
            # filter for rank
            if { ($srank <= $cur_rank) && ($cur_rank <= $erank) } {
                incr cnt
                 
                 # filter for query count
                 if { ($snum <= $cnt) && ($cnt <= $enum) } {

                    #set split_mask "^(\[0-9\]+) (.*) (.*) (\[0-9.,\]+) (\\[.*\\]) (.*) (\[0-9\]+) .*"
                    set split_mask {^(.+) (.+) (.+) (.+) (.+) (.+) (.+) .*}

                    if { [regexp -- $split_mask [::ds::color $chan $mmask $cdata] tmp ds_place ds_nick ds_sots_name ds_sots ds_al ds_race ds_rating] } {
                        if {[channel get $chan nocolorsds]} {
                            ::ds::out $nick $chan "$cnt: $ds_place $ds_nick $ds_sots_name $ds_sots $ds_al $ds_race $ds_rating"
                        } else {
                            #::ds::out $nick $chan [ ::ds::show_raw_color "$cnt: 
                            ::ds::out $nick $chan "$cnt: \
                            $ds(color_place)$ds_place \
                            $ds(color_nick)$ds_nick \
                            $ds(color_sots_name)$ds_sots_name \
                            $ds(color_sots)$ds_sots \
                            $ds(color_al)$ds_al \
                            $ds(color_race)$ds_race \
                            $ds(color_rating)$ds_rating \
                            $ds(color_def)"
                        }
                    } else {
                        ::ds::out $nick $chan "$cnt: [::ds::color $chan $mmask $cdata]"
                    }
                    #::ds::out $nick $chan "ds_place   $ds_place"
                    #::ds::out $nick $chan "ds_nick    $ds_nick"
                    #::ds::out $nick $chan "ds_sots_nam $ds_sots_name"
                    #::ds::out $nick $chan "ds_sots    $ds_sots"
                    #::ds::out $nick $chan "ds_al      $ds_al"
                    #::ds::out $nick $chan "ds_race    $ds_race"
                    #::ds::out $nick $chan "ds_rating  $ds_rating"
                }
            }
        }
    }
    #if {$showcnt == 0} {
    #        ::ds::out $nick $chan "  '$mask'   ..."
    #} else {
    #    if { $showcnt < $enum } { set enum $showcnt }
    #    if {$showcnt != $enum} {
    #        ::ds::out $nick $chan "  $snum  $enum  $showcnt   '$mask'..."
    #    }
    #}

    if {$cnt == 0} {
            ::ds::out $nick $chan "  '$mask'   ..."
    } else {
        if { $cnt < $enum } { set enum $cnt }
        if {$cnt != $enum} {
            ::ds::out $nick $chan "  $snum  $enum  $cnt   '$mask'..."
        }
    }
}

proc ::ds::color {chan what string} {
    global ds
	if {[channel get $chan nocolorsds]} {return $string}
    regsub -all -nocase -- $what $string $ds(color_mask)$what$ds(color_def) string
    return $string
}

# FIXME: not work.
proc ::ds::colors {chan string} {
	if {[channel get $chan nocolorsds]} {return $string}
    #regsub -all -- {\003[\d]{0,2}(,[\d]{0,2})?} $string {} string
    return $string
}

proc ::ds::out {nick chan text} {
	global botnick
	if {[validchan $chan]} {putserv "PRIVMSG $chan :[::ds::colors $chan $text]"
	} elseif {$nick != $botnick} {
		if {$nick == $chan} {putserv "PRIVMSG $nick :[::ds::colors $chan $text]"
		} else {putserv "NOTICE $nick :[::ds::colors $chan $text]"}
	}
}

proc ::ds::log {chan text} {
	if {[channel get $chan logsds]} {
        putlog $text
    }
}

proc ::ds::tolower {text} {
	return [string map {                                                                 } [string tolower $text]]
}

proc ::ds::rehash {min hour day week year} {
    global ds
    if {[catch {exec /bin/sh -c $ds(download_cmd)} 0]}  {
         return "\[ds\] error download '$ds(csvurl)'"
    } else {
        exec /bin/mv $ds(tmpfile) $ds(datafile)
        return [::ds::readdata]
    }
}

proc ::ds::pub_dsrehash {nick uhost hand chan args} {
    ::ds::out $nick $chan [::ds::rehash 0 0 0 0 0]
}


proc ::ds::show_raw_color {str} {                                                            
# FIXME: not work.
  regsub -all -- {\\}  $str {_} str;
  return $str                                                                       
}

proc ::ds::ctrl_filter {str} {                                                            
  regsub -all -- {([\003]{1}[0-9]{0,2}[\,]{0,1}[0-9]{0,2})} $str "" str; #color     
  regsub -all -- "\017" $str "" str; #plain                                         
  regsub -all -- "\037" $str "" str; #underline                                     
  regsub -all -- "\002" $str "" str; #bold                                          
  regsub -all -- "\026" $str "" str; #reverse                                       
  return $str                                                                       
}     

#foreach tmr [timers] {if {[lindex $tmr 1] == "::ds::readdata"} {killtimer [lindex $tmr 2]}}
::ds::readdata
#timer $ds(reloadtime) ::ds::readdata

putlog "ds.tcl v$ds(ver) by $ds(authors) loaded"
